// This file is part of Notepad++ project
// Copyright (C)2021 Don HO <don.h@free.fr>

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// at your option any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.


//代码整体实现了一个创建和销毁窗口的功能
//在VerticalFileSwitcherListView.h、URLCtrl.h、TreeView.h、ToolTip.h等文件里都引用了Window.h
//基本上只要是会弹出窗口的功能都需要引用此头文件
#pragma once
#include <windows.h>

class Window//定义了一个窗口类，包括了窗口的初始化、销毁、显示、重绘等操作
{
public:
	//! \name Constructors & Destructor
	//@{
	Window() = default;// 默认构造函数
	Window(const Window&) = delete;// 禁用拷贝构造函数
	virtual ~Window() = default;// 默认析构函数
	//@}

	// 初始化窗口
	virtual void init(HINSTANCE hInst, HWND parent)
	{
		_hInst = hInst;
		_hParent = parent;
	}

	virtual void destroy() = 0;// 销毁窗口

	virtual void display(bool toShow = true) const// 显示或隐藏窗口
	{
		::ShowWindow(_hSelf, toShow ? SW_SHOW : SW_HIDE);
	}

	// 调整窗口大小并重绘窗口内容
	virtual void reSizeTo(RECT & rc) // should NEVER be const !!!
	{
		::MoveWindow(_hSelf, rc.left, rc.top, rc.right, rc.bottom, TRUE);
		redraw();
	}

	// 调整窗口大小（传入宽度和高度）并重绘窗口内容
	virtual void reSizeToWH(RECT& rc) // should NEVER be const !!!
	{
		::MoveWindow(_hSelf, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, TRUE);
		redraw();
	}

	// 重绘窗口内容
	virtual void redraw(bool forceUpdate = false) const
	{
		::InvalidateRect(_hSelf, nullptr, TRUE);
		if (forceUpdate)
			::UpdateWindow(_hSelf);
	}

	// 获取窗口客户区矩形
    virtual void getClientRect(RECT & rc) const
	{
		::GetClientRect(_hSelf, &rc);
	}
	// 获取窗口矩形
	virtual void getWindowRect(RECT & rc) const
	{
		::GetWindowRect(_hSelf, &rc);
	}
	// 获取窗口宽度
	virtual int getWidth() const
	{
		RECT rc;
		::GetClientRect(_hSelf, &rc);
		return (rc.right - rc.left);
	}
	// 获取窗口高度
	virtual int getHeight() const
	{
		RECT rc;
		::GetClientRect(_hSelf, &rc);
		if (::IsWindowVisible(_hSelf) == TRUE)
			return (rc.bottom - rc.top);
		return 0;
	}
	// 判断窗口是否可见
	virtual bool isVisible() const
	{
    	return (::IsWindowVisible(_hSelf)?true:false);
	}

	HWND getHSelf() const
	{
		return _hSelf;
	}

	HWND getHParent() const {
		return _hParent;
	}

	void getFocus() const {
		::SetFocus(_hSelf);
	}

    HINSTANCE getHinst() const
	{
		//assert(_hInst != 0);
		return _hInst;
	}


	Window& operator = (const Window&) = delete;


protected:
	HINSTANCE _hInst = NULL;
	HWND _hParent = NULL;
	HWND _hSelf = NULL;
};